//+------------------------------------------------------------------+
//|                                                 Message Pane.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//--- names of graphical objects
string name="edit";
string back="rect";
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- set a rectangle as a background
   if(ObjectCreate(0,back,OBJ_RECTANGLE_LABEL,0,0,0))
     {
      //--- set its necessary properties
      ObjectSetInteger(0,back,OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
      ObjectSetInteger(0,back,OBJPROP_XDISTANCE,25);
      ObjectSetInteger(0,back,OBJPROP_YDISTANCE,25);
      ObjectSetInteger(0,back,OBJPROP_XSIZE,160);
      ObjectSetInteger(0,back,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,back,OBJPROP_COLOR,C'16,16,16');
      ObjectSetInteger(0,back,OBJPROP_BGCOLOR,C'218,236,254');
      ObjectSetInteger(0,back,OBJPROP_BORDER_TYPE,BORDER_FLAT);
      ObjectSetInteger(0,back,OBJPROP_SELECTABLE,true);
      //--- now create input field
      if(ObjectCreate(0,name,OBJ_EDIT,0,0,0))
        {
         //--- "Input field" object created, setting properties
         ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
         ObjectSetInteger(0,name,OBJPROP_XDISTANCE,30);
         ObjectSetInteger(0,name,OBJPROP_YDISTANCE,30);
         ObjectSetInteger(0,name,OBJPROP_XSIZE,150);
         ObjectSetInteger(0,name,OBJPROP_YSIZE,20);
         ObjectSetInteger(0,name,OBJPROP_COLOR,C'16,16,16');
         ObjectSetInteger(0,name,OBJPROP_BGCOLOR,clrWhite);
         ObjectSetString(0,name,OBJPROP_TEXT,"Enter message text");
         ChartRedraw(0);
        }
     }
   else // could not create "OBJ_RECTANGLE_LABEL" object
     {
      Print(__FUNCTION__,": Could not create RECTANGLE LABEL object, error code=",GetLastError());
      Print("EA initialization failed!");
      return(-1);
     }
//--- initialization successful  
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- delete all created objects
   if(!ObjectDelete(0,name)) Print("Failed to delete Edit field");
   if(!ObjectDelete(0,back)) Print("Failed to delete Background rectangle");
  }
//+------------------------------------------------------------------+
//| Chart Events Handler                                             |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
//--- Check if there is any text for sending a push notification
   if(id==CHARTEVENT_OBJECT_ENDEDIT)
     {
      //--- receive a text from the input field
      string a=ObjectGetString(0,name,OBJPROP_TEXT);
      if(StringLen(a)<255 && a!="Enter message text")
        {
         //--- sending a text
         bool res=SendNotification(a);
         if(!res) Print(__FUNCTION__,": SendNotification() execution failed, error code ",GetLastError());
        }
      else
        {
         Print("The message is too long to be sent via SendNotification()");
        }
     }
//--- Check object moving event
   if(id==CHARTEVENT_OBJECT_DRAG && sparam==back)
     {
      //--- receive OBJ_RECTANGLE_LABEL object coordinates and perform calculations for OBJ_EDIT
      int new_x=(int)ObjectGetInteger(0,back,OBJPROP_XDISTANCE)+5;
      int new_y=(int)ObjectGetInteger(0,back,OBJPROP_YDISTANCE)+5;
      //--- set new coordinates for OBJ_EDIT object
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,new_x);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,new_y);
      //--- chart forced redraw
      ChartRedraw(0);
     }
  }
//+------------------------------------------------------------------+
