//+------------------------------------------------------------------+
//|                                 SendNotificationSample.mq5       |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"

#define XRGB(r,g,b)    (0xFF000000|(uchar(r)<<16)|(uchar(g)<<8)|uchar(b))
//--- connect class libraries
#include <ChartObjects\ChartObjectsTxtControls.mqh>
//#include <ChartObjects\ChartObjectsShapes.mqh>
#include <ChartObjects\ChartObjectsBmpControls.mqh>
//--- background for graphical elements
CChartObjectBmpLabel Form;
//--- text input
CChartObjectEdit   InputText;
//--- message sending button
CChartObjectButton SendButton;
string sendbutton_name="SendButton";
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   int subwindow=0;
//--- create BitmapLabel used as a background for the button and input field
   Form.Create(0,"Form",subwindow,100,50);
   string res_name="::Canvas";              // resource name for creating a background
//--- array for storing an image
   uint  data[];
   ArrayResize(data,400*100);               // set the array size according to the background size
   ArrayInitialize(data,uCLR(clrBisque));   // background color
   ResourceCreate(res_name,data,400,100,0,0,0,COLOR_FORMAT_XRGB_NOALPHA);
   Form.BmpFileOn(res_name);                // set the background as the resource image
//--- prepare the input field
   InputText.Create(0,"InputText",subwindow,130,70,320,25);
   InputText.Description("");          // clear the input field
   InputText.BackColor(clrWhite);      // background color
   InputText.BorderColor(clrSlateGray);// border color
   InputText.Color(clrBlack);          // text color
//--- prepare the button
   SendButton.Create(0,sendbutton_name,subwindow,130,110,100,30);
   SendButton.Description("Send");
//--- update the chart to see our objects
   ChartRedraw();
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//--- checking the event following a mouse click
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      string clickedChartObject=sparam;
      //--- if the button for sending a message is pressed
      if(clickedChartObject==sendbutton_name)
        {
         //--- button state - pressed or not
         bool pressed=ObjectGetInteger(0,sendbutton_name,OBJPROP_STATE);
         //--- if the send button is pressed
         if(pressed)
           {
            Print("Sending message: ",InputText.Description());
            //--- sending a message
            bool result=SendNotification(InputText.Description());
            //--- a short pause to show that the button is pressed
            Sleep(100);
            //--- release the button
            ObjectSetInteger(0,sendbutton_name,OBJPROP_STATE,0);
            //--- sending failed
            if(!result)
              {
               //--- report the error code to a user
               MessageBox("Error code: "+(string)GetLastError(),"SendNotification()! function call error");
               //--- check the error code and offer a solution
               if(GetLastError()==4517)
                 {
                  Print("SendNotification()! function call error",
                  " Invalid notifications settings in the terminal (ID is not specified or push notifications are not enabled)");
                 }               
              }
           }

        }
     }
   ChartRedraw();// forced redraw of all chart objects
  }
//+------------------------------------------------------------------+
//| Additional function to transform color into uint                 |
//+------------------------------------------------------------------+
uint uCLR(const color clr)
  {
   return(XRGB((clr)&0x0FF,(clr)>>8,(clr)>>16));
  };
//+------------------------------------------------------------------+
